#ifndef SWIG_LIBWCCL_PARSEDEXPRESSION_I
#define SWIG_LIBWCCL_PARSEDEXPRESSION_I

%module libcclparsedexpression
%{
  #include <libwccl/ops/parsedexpression.h>
%}

%include "libcclexpression.i"
%include "std_string.i"

namespace Wccl {
  class ParsedExpression : public Expression {
  public:
    // TODO
    // const Value& operator[](const std::string& var_name) const;
    
    // template<class T>
    // const T& get(const std::string& var_name) const;
    
    // template<class T>
    // T& get(const std::string& var_name)

    // template<class T>
    // void set(const std::string& var_name, const T& value);

    void clean();
    // boost::shared_ptr<ParsedExpression> clone_ptr() const;
    // boost::shared_ptr<ParsedExpression> clone_clean_ptr() const;
    std::string variables_string(const Corpus2::Tagset& tagset) const;
    // std::ostream& dump_variables(std::ostream& ostream, const Corpus2::Tagset& tagset) const;

  protected:
    // explicit ParsedExpression(const Variables& variables);
    // boost::shared_ptr<Variables> variables_;
    virtual ParsedExpression* clone_internal() const = 0;
  };
}

using namespace std;
using namespace Wccl;

#endif /* SWIG_LIBWCCL_PARSEDEXPRESSION_I */
